Status: New Start date: 07 Oct 2019
Assignee:  % Done: 10%

Category:  Estimated time: 0.00 hour

Target version:  Spent time: 3.05 hours

Description

The old ApCoCoA UI (based on Eclipse/Java8) no longer works on more recent versions of GNU/Linux.

Implement a new UI, with more or less the same behaviour.

Task entrusted to Nguetsa.

Related issues:

Related to ApCoCoA - Design #1340: Interactive window and history mechanism New 16 Oct 2019

Related to ApCoCoA - Feature #1354: ApCoCoA: separate window for manual New 29 Oct 2019

Related to ApCoCoA - Design #1357: How to connect GUI to cocoa5 executable? New 30 Oct 2019

History

#1 - 09 Oct 2019 19:33 - John Abbott

What characteristics of the new UI must be tested?

Here is a list: probably each entry here will correspond to a new separate issue (or perhaps more than one)

access to CoCoA and ApCoCoA online manual (in separate window)

handle large outputs gracefully  (e.g. long lines and/or many lines)

clearing all or part of the output window

editable windows for typing in CoCoA commands and function definitions

execution of commands from a window (or from a selected region of a window)

error messages giving helpful indication of where the error was found

saving to a file, reading from a file into a window

cocoa5 command line parameters?  e.g.  --allow-system-cmd

#2 - 09 Oct 2019 19:36 - John Abbott

Next meeting with Nguetsa:  Wed 16th Oct, at 14:00.

Intro to redmine; plan for next 2 weeks.  New version of cocoa5.  Initial set of tests.

#3 - 11 Oct 2019 15:18 - John Abbott

Here are the main features of the UI which Martin wants to preserve:

allow cut-and-paste of arbitrarily large text blocks

allow cut-and-paste from any window to any other window

allow several source windows to be open simultaneously (switch between them using tabs)

source window may(must?) be associated to a file

syntax highlighting in source windows (low priority)

files are stored in different "projects" (a proj is just a directory)

have a window listing projects, and able to show files in a project (each file may be opened into a new source window)
send contents of a source window to the execution window

execution window must handle well large outputs and long lines (e.g. > 1Mbyte long)

have an interactive window with history mechanism

separate window for man pages

Probably some more.

#4 - 16 Oct 2019 14:39 - John Abbott

- Related to Design #1340: Interactive window and history mechanism added

#5 - 16 Oct 2019 14:58 - John Abbott

2019-10-16 Current state

Klaus summarises the current state as follows:

early prototype

JAA confirms that UI works with an interactive window and separate output window

syntax highlighting is active in windows associated to CoCoA input

#6 - 29 Oct 2019 11:30 - John Abbott

- Related to Feature #1354: ApCoCoA: separate window for manual added

#7 - 30 Oct 2019 11:02 - John Abbott

- Related to Design #1357: How to connect GUI to cocoa5 executable? added

#8 - 31 Oct 2019 11:17 - John Abbott

Next meeting is 2019-11-21 at 11:00.

AIM: get interactive window and history mechanism working.

#9 - 04 Dec 2019 17:15 - John Abbott

- % Done changed from 0 to 10

Meeting today (2019-12-04).

Nguetsa reports: Interface is working, and history mechanism too.  Also interfaces well with CoCoA-5.
